/******************************************************************************\
 * LATSMB.C -- User modification to PRTSMB to make it work like LATSYM        *
\******************************************************************************/

#include "$psmdef.h"

latsmb_modify()
{       long latsmb_job_completion(), latsmb_output();
        PSM$REPLACE(&PSM$K_JOB_COMPLETION, latsmb_job_completion);
        PSM$REPLACE(&PSM$K_OUTPUT, latsmb_output);
        PSM$PRINT(0, 0, 0);
}

#include descrip
#include psmmsgdef

long close_it;

latsmb_job_completion(long *request_id, long *work_area, long *func,
    struct dsc$descriptor *funcdesc, long *funcarg)
{   static char eof[] = "\f";
    static int sent_eof = 0;

    if(*func == PSM$K_READ)
    {   if(sent_eof == 0)
        {   funcdesc->dsc$b_class = DSC$K_CLASS_S;
            funcdesc->dsc$a_pointer = &eof;
            funcdesc->dsc$w_length = 1;
            sent_eof = 1;
            close_it = 1;
            return 1;
        }
        else
            return PSM$_EOF;
    }
    else if(*func == PSM$K_OPEN || *func == PSM$K_CLOSE)
    {   sent_eof = 0;
        return 1;
    }
    else
        return PSM$_FUNNOTSUP;
}

#include dcdef
#include dvidef
#include iodef
#include lpdef
#include ssdef
#include ttdef
#include "$smbdef.h"
#define ckstat(x) if(((STAT = x) & 7) != 1) return STAT

latsmb_output(long *request_id, long *work_area, long *func,
    struct dsc$descriptor *funcdesc, long *funcarg)
{   struct
    {   short stat, count;
        long not_used;
    } iosb;
    static long chan;
    long STAT, stats[4], i;
    static char buffer[64];
    static $DESCRIPTOR(devnam, buffer);

    if(*func == PSM$K_OPEN)
    {   long devclass, devdepend;
        struct
        {       short buflen, itmcod;
                long bufadr, lenadr;
        } itmlst[3] =
        {       { 4, DVI$_DEVCLASS | DVI$C_SECONDARY, &devclass, 0 },
                { 4, DVI$_DEVDEPEND | DVI$C_SECONDARY, &devdepend, 0},
                { 0, 0, 0, 0 }
        };

        ckstat(SYS$GETDVIW(0, 0, funcdesc, itmlst, &iosb, 0, 0, 0));
        if(devclass == DC$_LP)
            *funcarg = (devdepend & LP$M_LOWER) == 0 ? 0 : SMBMSG$M_LOWERCASE;
        else if(devclass == DC$_TERM)
            *funcarg = SMBMSG$M_TERMINAL |
            ((devdepend & TT$M_LOWER) == 0 ? 0 : SMBMSG$M_LOWERCASE) |
            ((devdepend & TT$M_MODEM) == 0 ? 0 : SMBMSG$M_REMOTE);
        else
                return SS$_IVDEVNAM;
        ckstat(SYS$ALLOC(funcdesc, 0, 0, 0, 0));
        ckstat(SYS$ASSIGN(funcdesc, &chan, 0, 0));
        for(i = 0; i < funcdesc->dsc$w_length; ++i)
            buffer[i] = funcdesc->dsc$a_pointer[i];
        devnam.dsc$w_length = funcdesc->dsc$w_length;
        close_it = 0;
    }
    else if(*func == PSM$K_WRITE || *func == PSM$K_WRITE_NOFORMAT)
    {   stats[0] = SYS$QIOW(0, chan, *func == PSM$K_WRITE ? IO$_WRITELBLK :
            IO$_WRITEPBLK, &iosb, 0, 0, funcdesc->dsc$a_pointer,
            funcdesc->dsc$w_length, 0,  0, 0, 0);
        stats[1] = iosb.stat;
        stats[2] = stats[3] = 1;
        if (close_it == 1)
        {       stats[2] = SYS$QIOW(0,chan,IO$_TTY_PORT|IO$M_LT_DISCON,&iosb,
                        0,0,0,0,0,0,0,0);
                if (stats[2] == SS$_ILLIOFUNC)
                        stats[2] = stats[3] = 1;
                else
                        stats[3] = iosb.stat;
                close_it = 0;
        }
        ckstat(stats[0]);
        ckstat(stats[1]);
        ckstat(stats[2]);
        ckstat(stats[3]);
    }
    else if(*func == PSM$K_CLOSE)
    {   SYS$DASSGN(chan);
        ckstat(SYS$DALLOC(&devnam, 0));
    }
    else if(*func != PSM$K_CANCEL)
        return PSM$_FUNNOTSUP;
    return 1;
}
